      SUBROUTINE AEG2C(N,AR,AI,EVR,EVI,IEER)
      DIMENSION AR(N,N),AI(N,N),EVR(N),EVI(N)
      INTEGER N,IERR,IR1,IR2,A,B,C,D,E,F,G,H,R,S,T,U,V,W,X,
     1Y,MIN0
      REAL AR,AI,EVR,EVI,K,L,M,O,P,Q,SQRT,CABS,ABS,Z,BA,BB,
     1BC,BD,BE,BF,BG,BH,BI,BJ,REAL,AIMAG,SYS051
      COMPLEX CMPLX,BL,CSQRT
      DATA  SYS051/1.192093E-07/
      IR1=1
      IR2=N
      F=IR2-1
      H=IR1+1
      IF(F.LT.H) GO TO 12
      DO 11 C=H,F
      M=0.0
      EVR(C)=0.0
      EVI(C)=0.0
      Q=0.0
      DO 1 A=C,IR2
    1 Q=Q+ABS(AR(A,C-1))+ABS(AI(A,C-1))
      IF(Q.EQ.0.0) GO TO 11
      G=C+IR2
      DO 2 D=C,IR2
      A=G-D
      EVR(A)=AR(A,C-1)/Q
      EVI(A)=AI(A,C-1)/Q
      M=M+EVR(A)*EVR(A)+EVI(A)*EVI(A)
    2 CONTINUE
      L=SQRT(M)
      K=CABS(CMPLX(EVR(C),EVI(C)))
      IF(K.EQ.0.0) GO TO 3
      M=M+K*L
      L=L/K
      EVR(C)=(1.0+L)*EVR(C)
      EVI(C)=(1.0+L)*EVI(C)
      GO TO 4
    3 EVR(C)=L
      AR(C,C-1)=Q
    4 DO 7 B=C,N
      P=0.0
      O=0.0
      DO 5 D=C,IR2
      A=G-D
      P=P+EVR(A)*AR(A,B)+EVI(A)*AI(A,B)
      O=O+EVR(A)*AI(A,B)-EVI(A)*AR(A,B)
    5 CONTINUE
      P=P/M
      O=O/M
      DO 6 A=C,IR2
      AR(A,B)=AR(A,B)-P*EVR(A)+O*EVI(A)
      AI(A,B)=AI(A,B)-P*EVI(A)-O*EVR(A)
    6 CONTINUE
    7 CONTINUE
      DO 10 A=1,IR2
      P=0.0
      O=0.0
      DO 8 E=C,IR2
      B=G-E
      P=P+EVR(B)*AR(A,B)-EVI(B)*AI(A,B)
      O=O+EVR(B)*AI(A,B)+EVI(B)*AR(A,B)
    8 CONTINUE
      P=P/M
      O=O/M
      DO 9 B=C,IR2
      AI(A,B)=AI(A,B)+P*EVI(B)-O*EVR(B)
      AR(A,B)=AR(A,B)-P*EVR(B)-O*EVI(B)
    9 CONTINUE
   10 CONTINUE
      EVR(C)=Q*EVR(C)
      EVI(C)=Q*EVI(C)
      AR(C,C-1)=-L*AR(C,C-1)
      AI(C,C-1)=-L*AI(C,C-1)
   11 CONTINUE
   12 IERR=0
      IF(IR1.EQ.IR2) GO TO 16
      T=IR1+1
      DO 15 R=T,IR2
      V=MIN0(R+1,IR2)
      IF(AI(R,R-1).EQ.0.0) GO TO 15
      BJ=CABS(CMPLX(AR(R,R-1),AI(R,R-1)))
      BG=AR(R,R-1)/BJ
      BF=AI(R,R-1)/BJ
      AR(R,R-1)=BJ
      AI(R,R-1)=0.0
      DO 13 S=R,IR2
      Z=BG*AI(R,S)-BF*AR(R,S)
      AR(R,S)=BG*AR(R,S)+BF*AI(R,S)
      AI(R,S)=Z
   13 CONTINUE
      DO 14 S=IR1,V
      Z=BG*AI(S,R)+BF*AR(S,R)
      AR(S,R)=BG*AR(S,R)-BF*AI(S,R)
      AI(S,R)=Z
   14 CONTINUE
   15 CONTINUE
   16 DO 17 R=1,N
      IF(R.GE.IR1.AND.R.LE.IR2) GO TO 17
      EVR(R)=AR(R,R)
      EVI(R)=AI(R,R)
   17 CONTINUE
      U=IR2
      BC=0.0
      BB=0.0
   18 IF(U.LT.IR1) GO TO 35
      W=0
      Y=U-1
   19 DO 20 V=IR1,U
      T=U+IR1-V
      IF(T.EQ.IR1) GO TO 21
      IF(ABS(AR(T,T-1)).LE.SYS051*(ABS(AR(T-1,T-1))+
     1ABS(AI(T-1,T-1))+ABS(AR(T,T))+ABS(AI(T,T)))) GO TO 21
   20 CONTINUE
   21 IF(T.EQ.U) GO TO 33
      IF(W.EQ.30) GO TO 34
      IF(W.EQ.10.OR.W.EQ.20) GO TO 23
      BA=AR(U,U)
      Z=AI(U,U)
      BE=AR(Y,U)*AR(U,Y)
      BD=AI(Y,U)*AR(U,Y)
      IF(BE.EQ.0.0.AND.BD.EQ.0.0) GO TO 24
      BG=(AR(Y,Y)-BA)/2.0
      BF=(AI(Y,Y)-Z)/2.0
      BL=CSQRT(CMPLX(BG**2-BF**2+BE,2.0*BG*BF+BD))
      BI=REAL(BL)
      BH=AIMAG(BL)
      IF(BG*BI+BF*BH.GE.0.0) GO TO 22
      BI=-BI
      BH=-BH
   22 BL=CMPLX(BE,BD)/CMPLX(BG+BI,BF+BH)
      BA=BA-REAL(BL)
      Z=Z-AIMAG(BL)
      GO TO 24
   23 BA=ABS(AR(U,Y))+ABS(AR(Y,U-2))
      Z=0.0
   24 DO 25 R=IR1,U
      AR(R,R)=AR(R,R)-BA
      AI(R,R)=AI(R,R)-Z
   25 CONTINUE
      BC=BC+BA
      BB=BB+Z
      W=W+1
      X=T+1
      DO 27 R=X,U
      BA=AR(R,R-1)
      AR(R,R-1)=0.0
      BJ=SQRT(AR(R-1,R-1)*AR(R-1,R-1)+AI(R-1,R-1)*AI(R-1,R-
     11)+BA*BA)
      BE=AR(R-1,R-1)/BJ
      EVR(R-1)=BE
      BD=AI(R-1,R-1)/BJ
      EVI(R-1)=BD
      AR(R-1,R-1)=BJ
      AI(R-1,R-1)=0.0
      AI(R,R-1)=BA/BJ
      DO 26 S=R,U
      BG=AR(R-1,S)
      BF=AI(R-1,S)
      BI=AR(R,S)
      BH=AI(R,S)
      AR(R-1,S)=BE*BG+BD*BF+AI(R,R-1)*BI
      AI(R-1,S)=BE*BF-BD*BG+AI(R,R-1)*BH
      AR(R,S)=BE*BI-BD*BH-AI(R,R-1)*BG
      AI(R,S)=BE*BH+BD*BI-AI(R,R-1)*BF
   26 CONTINUE
   27 CONTINUE
      Z=AI(U,U)
      IF(Z.EQ.0.0) GO TO 28
      BJ=CABS(CMPLX(AR(U,U),Z))
      BA=AR(U,U)/BJ
      Z=Z/BJ
      AR(U,U)=BJ
      AI(U,U)=0.0
   28 DO 31 S=X,U
      BE=EVR(S-1)
      BD=EVI(S-1)
      DO 30 R=T,S
      BG=AR(R,S-1)
      BF=0.0
      BI=AR(R,S)
      BH=AI(R,S)
      IF(R.EQ.S) GO TO 29
      BF=AI(R,S-1)
      AI(R,S-1)=BE*BF+BD*BG+AI(S,S-1)*BH
   29 AR(R,S-1)=BE*BG-BD*BF+AI(S,S-1)*BI
      AR(R,S)=BE*BI+BD*BH-AI(S,S-1)*BG
      AI(R,S)=BE*BH-BD*BI-AI(S,S-1)*BF
   30 CONTINUE
   31 CONTINUE
      IF(Z.EQ.0.0) GO TO 19
      DO 32 R=T,U
      BG=AR(R,U)
      BF=AI(R,U)
      AR(R,U)=BA*BG-Z*BF
      AI(R,U)=BA*BF+Z*BG
   32 CONTINUE
      GO TO 19
   33 EVR(U)=AR(U,U)+BC
      EVI(U)=AI(U,U)+BB
      U=Y
      GO TO 18
   34 IERR=U
   35 IF(IERR.NE.0) CALL UTAE10(IERR,N,30)
      RETURN
      END
